﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectInput;

namespace RescueRoboControl
{
    public partial class Form1 : Form
    {
        Udp udp;
        Device joystick;
        public Form1()
        {
            Device[] devar = new Device[256];
            int i = 0;

            InitializeComponent();

            // ゲームコントローラのデバイス一覧を取得
            DeviceList devList = Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly);

            // 全てのコントローラを列挙
            foreach (DeviceInstance dev in devList)
            {
                devar[i++] = new Device(dev.InstanceGuid);
                Console.WriteLine(dev.ProductName);
            }
            // 最初に見つかったジョイスティックを操作対象とする
            if (0 < i)
            {
                joystick = devar[0];

                //Set joystick axis ranges.
                foreach (DeviceObjectInstance doi in joystick.Objects)
                {
                    if ((doi.ObjectId & (int)DeviceObjectTypeFlags.Axis) != 0)
                    {
                        joystick.Properties.SetRange(
                            ParameterHow.ById,
                            doi.ObjectId,
                            new InputRange(0, 255));
                    }
                } 

                joystick.SetCooperativeLevel(this, CooperativeLevelFlags.Background | CooperativeLevelFlags.NonExclusive);


                joystick.SetDataFormat(DeviceDataFormat.Joystick);

                // デバイスに対するアクセス権をとる
                joystick.Acquire();

                Console.WriteLine("Usage: " + joystick.DeviceInformation.Usage.ToString() + Environment.NewLine);
                Console.WriteLine("名称: " + joystick.DeviceInformation.ProductName + Environment.NewLine);
                // コントローラの軸の数
                Console.WriteLine("軸の数: " + joystick.Caps.NumberAxes + Environment.NewLine);
                // コントローラに有るボタンの数
                Console.WriteLine("ボタンの数: " + joystick.Caps.NumberButtons + Environment.NewLine);
                // PoV hatの数
                Console.WriteLine("PoVハットの数: " + joystick.Caps.NumberPointOfViews + Environment.NewLine);
            }
            timer1.Start();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            udp = new Udp();
            this.trackBar1.Value = udp.GetVal(6);
            this.trackBarViewH.Value = udp.GetVal(7);
            this.trackBarViewV.Value = udp.GetVal(8);
            udp.SendUdp();
        }

        private void Stop_Click(object sender, EventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.Val(4, 0);
            udp.Val(5, 0);
            udp.SendUdp();
        }


        private void Front_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 1);
            udp.Val(1, 0);
            udp.Val(2, 1);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void Front_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void Back_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 1);
            udp.Val(2, 0);
            udp.Val(3, 1);
            udp.SendUdp();
        }

        private void Back_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void LeftTurn_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 1);
            udp.Val(2, 1);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void LeftTurn_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void RightTurn_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 1);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 1);
            udp.SendUdp();
        }

        private void RightTurn_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void FrontLeft_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 1);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void FrontLeft_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void FrontRight_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 1);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void FrontRight_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void BackLeft_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 1);
            udp.SendUdp();
        }

        private void BackLeft_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void BackRight_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 1);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void BackRight_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(0, 0);
            udp.Val(1, 0);
            udp.Val(2, 0);
            udp.Val(3, 0);
            udp.SendUdp();
        }

        private void Up_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(4, 1);
            udp.Val(5, 0);
            udp.SendUdp();
        }

        private void Up_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(4, 0);
            udp.Val(5, 0);
            udp.SendUdp();
        }

        private void Down_MouseDown(object sender, MouseEventArgs e)
        {
            udp.Val(4, 0);
            udp.Val(5, 1);
            udp.SendUdp();
        }

        private void Down_MouseUp(object sender, MouseEventArgs e)
        {
            udp.Val(4, 0);
            udp.Val(5, 0);
            udp.SendUdp();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            udp.Val(6, trackBar1.Value);
            udp.SendUdp();
        }

        private void trackBarViewH_Scroll(object sender, EventArgs e)
        {
            udp.Val(7, trackBarViewH.Value);
            udp.SendUdp();
        }

        private void trackBarViewV_Scroll(object sender, EventArgs e)
        {
            udp.Val(8, trackBarViewV.Value);
            udp.SendUdp();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int lu,ll,ru,rl;
            int plus = 160;
            int minus = 96;

            if (joystick == null) {
                return;
            }

            try
            {
                joystick.Poll();
                JoystickState state = joystick.CurrentJoystickState;

                // カメラスティック Exponential

                //int Hval = 255 - state.X;
                int Hval = 255 - state.X-128;
                Hval = Hval*Hval*Hval;
                Hval = Hval / 16384 + 128;
                this.trackBarViewH.Value = Hval;
                udp.Val(7, trackBarViewH.Value);

                //int Vval = state.Y;
                int Vval = state.Y-128;
                Vval = (Vval * Vval * Vval) / 16384 + 128;
                this.trackBarViewV.Value = Vval;
                udp.Val(8, trackBarViewV.Value);

                // 移動用スティック
                if (state.Ry<minus) {
                    if ( state.Rx<minus) {
                        lu=1;ll=0;ru=0;rl=0;
                    } else if(plus<state.Rx) {
                        lu=0;ll=0;ru=1;rl=0;
                    } else {
                        lu=1;ll=0;ru=1;rl=0;
                    }
                } else if(plus<state.Ry) {
                    if ( state.Rx<minus) {
                        lu=0;ll=1;ru=0;rl=0;
                    } else if(plus<state.Rx) {
                        lu=0;ll=0;ru=0;rl=1;
                    } else {
                        lu=0;ll=1;ru=0;rl=1;
                    }
                } else {
                    if ( state.Rx<minus) {
                        lu=1;ll=0;ru=0;rl=1;
                    } else if(plus<state.Rx) {
                        lu=0;ll=1;ru=1;rl=0;
                    } else {
                        lu=0;ll=0;ru=0;rl=0;
                    }
                }
                udp.Val(0, ru);
                udp.Val(1, rl);
                udp.Val(2, lu);
                udp.Val(3, ll);


                int pmax=Math.Abs(state.Rx - 128);
                if (pmax < Math.Abs(state.Ry - 128)) { pmax = Math.Abs(state.Ry - 128); }
                pmax = pmax * 2;
                if (255<pmax) { pmax=255;}
                this.trackBar1.Value = pmax;
                udp.Val(6, trackBar1.Value);

                byte[] button = state.GetButtons();
                if (0 < button[0]) {
                    udp.Val(4, 1);
                } else {
                    udp.Val(4, 0);
                }

                if (0 < button[1]) {
                    udp.Val(5, 1);
                } else {
                    udp.Val(5, 0);
                }

                if (0 < button[2])
                {
                    udp.Val(9, 1);
                }
                else
                {
                    udp.Val(9, 0);
                }

                udp.SendUdp();

            }
            catch (Exception ex)
            {
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                timer1.Start();
            }
            else
            {
                timer1.Stop();
            }
        }

        private void checkBoxLED_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxLED.Checked)
            {
                udp.Val(9, 1);
            }
            else
            {
                udp.Val(9, 0);
            }
            udp.SendUdp();
        }
    }
}
