﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RescueRoboControl
{
    class Udp
    {
        private int portdef = 8765;
        private string hostdef = "192.168.1.4";
        private int port = 0;
        private string host = "";
        private System.Net.Sockets.UdpClient udp;
        private System.Text.Encoding enc;
        //ASCIIEncoding enc = new ASCIIEncoding();

        private int[] contval = new int[]{0,0,0,0,0,0,128,128,128,0};

        public Udp()
        {
            enc = System.Text.Encoding.UTF8;
            udp = new System.Net.Sockets.UdpClient(port);
            try
            {
                host = (string)Microsoft.Win32.Registry.GetValue(
                    @"HKEY_CURRENT_USER\Software\HOIHOIDO\Rescuectrl\HOST", "string", "default");
                port = (int)Microsoft.Win32.Registry.GetValue(
                    @"HKEY_CURRENT_USER\Software\HOIHOIDO\Rescuectrl\PORT", "int", 0);
            }
            catch (Exception ex)
            {
                Microsoft.Win32.Registry.SetValue(
                    @"HKEY_CURRENT_USER\Software\HOIHOIDO\Rescuectrl\HOST", "string", hostdef);
                Microsoft.Win32.Registry.SetValue(
                    @"HKEY_CURRENT_USER\Software\HOIHOIDO\Rescuectrl\PORT", "int", portdef);
                host = hostdef;
                port = portdef;
            }
        }

        public void SendUdp()
        {
            string sendmsg = string.Format("{0},{1},{2},{3},{4},{5},{6},{7},{8},{9}\0",
                contval[0], contval[1], contval[2], contval[3], contval[4],
                contval[5], contval[6], contval[7], contval[8], contval[9]);
            byte[] sendBytes = enc.GetBytes(sendmsg);

            //Console.WriteLine(BitConverter.ToString(sendBytes));
            udp.Send(sendBytes, sendBytes.Length, host, port);
            //MessageBox.Show(sendmsg);
        }

        public void Val(int i , int value)
        {
            contval[i] = value;
        }

        public int GetVal(int i)
        {
            return contval[i];
        }
    }
}
